package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.BleManager _manager = null;
public static anywheresoftware.b4a.objects.collections.List _cs = null;
public anywheresoftware.b4a.objects.ListViewWrapper _listview1 = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 27;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 28;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 29;BA.debugLine="Activity.LoadLayout(\"main\")";
mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
 //BA.debugLineNum = 30;BA.debugLine="Activity.AddMenuItem(\"Scan Devices\",\"mnuscan\")";
mostCurrent._activity.AddMenuItem("Scan Devices","mnuscan");
 //BA.debugLineNum = 31;BA.debugLine="manager.Initialize(\"ble\")";
_manager.Initialize(processBA,"ble");
 //BA.debugLineNum = 32;BA.debugLine="ToastMessageShow(\"Supported: \" & manager.BleS";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Supported: "+BA.ObjectToString(_manager.getBleSupported()),anywheresoftware.b4a.keywords.Common.False);
 };
 //BA.debugLineNum = 34;BA.debugLine="End Sub";
return "";
}
public static String  _ble_characteristicread(boolean _success,anywheresoftware.b4a.objects.BleManager.GattCharacteristic _characteristic) throws Exception{
 //BA.debugLineNum = 65;BA.debugLine="Sub BLE_CharacteristicRead (Success As Boolean, Ch";
 //BA.debugLineNum = 66;BA.debugLine="ToastMessageShow(\"CR: \" & Success & \": \" & Chara";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("CR: "+BA.ObjectToString(_success)+": "+_characteristic.getUuid(),anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 67;BA.debugLine="If Success Then ToastMessageShow(\"cr: \" & Chara";
if (_success) { 
anywheresoftware.b4a.keywords.Common.ToastMessageShow("cr: "+_characteristic.GetStringValue((int) (0)),anywheresoftware.b4a.keywords.Common.False);};
 //BA.debugLineNum = 68;BA.debugLine="End Sub";
return "";
}
public static String  _ble_connected(anywheresoftware.b4a.objects.collections.Map _services) throws Exception{
anywheresoftware.b4a.objects.BleManager.GattServiceWrapper _s = null;
anywheresoftware.b4a.objects.BleManager.GattCharacteristic _c = null;
 //BA.debugLineNum = 57;BA.debugLine="Sub BLE_Connected (Services As Map)";
 //BA.debugLineNum = 58;BA.debugLine="cs.Initialize";
_cs.Initialize();
 //BA.debugLineNum = 59;BA.debugLine="Dim s As BleService = Services.GetValueAt(0)";
_s = new anywheresoftware.b4a.objects.BleManager.GattServiceWrapper();
_s.setObject((android.bluetooth.BluetoothGattService)(_services.GetValueAt((int) (0))));
 //BA.debugLineNum = 61;BA.debugLine="Dim c As BleCharacteristic = s.GetCharacteristi";
_c = new anywheresoftware.b4a.objects.BleManager.GattCharacteristic();
_c.setObject((android.bluetooth.BluetoothGattCharacteristic)(_s.GetCharacteristics().Get((Object)("00002a00-0000-1000-8000-00805f9b34fb"))));
 //BA.debugLineNum = 62;BA.debugLine="manager.ReadCharacteristic(c)";
_manager.ReadCharacteristic(_c);
 //BA.debugLineNum = 63;BA.debugLine="End Sub";
return "";
}
public static String  _ble_devicefound(String _name,String _macaddress,int _rssi,byte[] _scanrecord) throws Exception{
int _i = 0;
String _sbatt = "";
String _stemp = "";
String _shumidity = "";
 //BA.debugLineNum = 40;BA.debugLine="Sub BLE_DeviceFound (Name As String, MacAddress As";
 //BA.debugLineNum = 41;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 42;BA.debugLine="Dim sBatt As String = \"0\", sTemp As String = \"0";
_sbatt = "0";
_stemp = "0";
_shumidity = "0";
 //BA.debugLineNum = 43;BA.debugLine="For i = 0 To scanRecord.Length -1";
{
final int step23 = 1;
final int limit23 = (int) (_scanrecord.length-1);
for (_i = (int) (0); (step23 > 0 && _i <= limit23) || (step23 < 0 && _i >= limit23); _i = ((int)(0 + _i + step23))) {
 //BA.debugLineNum = 44;BA.debugLine="If (i+7 < scanRecord.Length) Then";
if ((_i+7<_scanrecord.length)) { 
 //BA.debugLineNum = 45;BA.debugLine="If (scanRecord(i) = 7 AND scanRecord(i+1) = 2";
if ((_scanrecord[_i]==7 && _scanrecord[(int) (_i+1)]==22 && _scanrecord[(int) (_i+2)]==0 && _scanrecord[(int) (_i+3)]==-80)) { 
 //BA.debugLineNum = 47;BA.debugLine="sBatt = scanRecord(i+7)";
_sbatt = BA.NumberToString(_scanrecord[(int) (_i+7)]);
 //BA.debugLineNum = 48;BA.debugLine="sHumidity = scanRecord(i+6)";
_shumidity = BA.NumberToString(_scanrecord[(int) (_i+6)]);
 //BA.debugLineNum = 49;BA.debugLine="sTemp = scanRecord(i+5)";
_stemp = BA.NumberToString(_scanrecord[(int) (_i+5)]);
 };
 };
 }
};
 //BA.debugLineNum = 53;BA.debugLine="ListView1.AddTwoLines2(Name,rssi & \" dBm: batt";
mostCurrent._listview1.AddTwoLines2(_name,BA.NumberToString(_rssi)+" dBm: batt "+_sbatt+" %: temp "+_stemp+" c: humi "+_shumidity+" %",(Object)(_macaddress));
 //BA.debugLineNum = 55;BA.debugLine="End Sub";
return "";
}
public static String  _ble_disconnected() throws Exception{
 //BA.debugLineNum = 70;BA.debugLine="Sub ble_Disconnected";
 //BA.debugLineNum = 71;BA.debugLine="Log(\"Disconnected\")";
anywheresoftware.b4a.keywords.Common.Log("Disconnected");
 //BA.debugLineNum = 72;BA.debugLine="End Sub";
return "";
}
public static String  _ble_discoveryfinished() throws Exception{
 //BA.debugLineNum = 74;BA.debugLine="Sub ble_DiscoveryFinished";
 //BA.debugLineNum = 75;BA.debugLine="Log(\"DiscoveryFinished\")";
anywheresoftware.b4a.keywords.Common.Log("DiscoveryFinished");
 //BA.debugLineNum = 76;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 20;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 24;BA.debugLine="Private ListView1 As ListView";
mostCurrent._listview1 = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _mnuscan_click() throws Exception{
 //BA.debugLineNum = 35;BA.debugLine="Sub mnuscan_Click";
 //BA.debugLineNum = 36;BA.debugLine="ToastMessageShow(\"Searching for devices\", False";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Searching for devices",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 37;BA.debugLine="ListView1.Clear";
mostCurrent._listview1.Clear();
 //BA.debugLineNum = 38;BA.debugLine="manager.Scan(5000, Null)";
_manager.Scan(processBA,(long) (5000),(String[])(anywheresoftware.b4a.keywords.Common.Null));
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 16;BA.debugLine="Dim manager As BleManager";
_manager = new anywheresoftware.b4a.objects.BleManager();
 //BA.debugLineNum = 17;BA.debugLine="Private cs As List";
_cs = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 18;BA.debugLine="End Sub";
return "";
}
}
